package com.iformall.controller.market;

import com.alibaba.fastjson.JSON;
import com.github.pagehelper.PageInfo;
import com.iformall.annotation.SystemControllerLog;
import com.iformall.common.Result;
import com.iformall.common.ResultData;
import com.iformall.controller.base.BaseController;
import com.iformall.domain.po.base.BaseEntity;
import com.iformall.domain.po.MallUserInfo;
import com.iformall.domain.po.WxCouponInject;
import com.iformall.service.WxCouponInjectService;
import com.iformall.service.WxCUserTagsService;
import com.iformall.service.WxMsgModelService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("couponInject")
@Api(description = "精准投放接口")
public class WxCouponInjectController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private WxCouponInjectService wxCouponInjectService;
    @Autowired
    private WxCUserTagsService wxCUserTagsService;
    @Autowired
    private WxMsgModelService wxMsgModelService;

    @ApiOperation("分页列表接口")
    @GetMapping("list")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    @SystemControllerLog(description = "精准投放-列表")
    public ResultData list(@ModelAttribute WxCouponInject couponInject, Integer pageNum, Integer pageSize) {
        logger.debug("[" + getIpAddr() + "] WxCouponInjectController::list");
        if (null == couponInject) couponInject = new WxCouponInject();
        if (couponInject.getStatus() != null && couponInject.getStatus() == -1) {
            couponInject.setStatus(null);
        }
        couponInject.setTenantId(getTenantId());
        couponInject.setSortColumns(BaseEntity.SortField.CreateTime_DESC,BaseEntity.SortField.Id_DESC);
        final PageInfo<WxCouponInject> page = wxCouponInjectService.listAsPage(couponInject, pageNum, pageSize);
        return new ResultData(page);
    }

    @ApiOperation("新增接口")
    @PostMapping("add")
    @SystemControllerLog(description = "精准投放-新增")
    public ResultData add(@RequestBody WxCouponInject couponInject) {
        logger.debug("[" + getIpAddr() + "] WxCouponInjectController::add");

        MallUserInfo user = getUser();
        couponInject.setTenantId(user.getTenantId());
        couponInject.setMUserId(user.getId());

        return wxCouponInjectService.add(couponInject);
    }

    @ApiOperation("根据id更新接口")
    @PostMapping("update")
    @SystemControllerLog(description = "精准投放-更新")
    public ResultData update(@RequestBody WxCouponInject couponInject) {
        logger.debug("[" + getIpAddr() + "] WxCouponInjectController::update");

        couponInject.setTags(JSON.toJSONString(couponInject.getFilterList()));
        wxCouponInjectService.saveOrUpdate(couponInject);
        return new ResultData();
    }

    @ApiOperation("根据id删除接口")
    @GetMapping("/del")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "精准投放-删除")
    public ResultData delete(Long id) {
        logger.debug("[" + getIpAddr() + "] WxCouponInjectController::delete");
        wxCouponInjectService.deleteById(id);
        return new ResultData(Result.SUCCESS, "删除成功", null);
    }

    @ApiOperation("根据id查询接口")
    @GetMapping("/findById")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "精准投放-查询")
    public ResultData findById(Long id) {
        logger.debug("[" + getIpAddr() + "] WxCouponInjectController::findById");
        WxCouponInject couponInject = wxCouponInjectService.getById(id);
        if (couponInject != null) {
            couponInject.setMsgModel(wxMsgModelService.getById(couponInject.getModelId()));
        }
        return new ResultData(Result.SUCCESS, "查询成功", couponInject);
    }


}
